local TICRATE = TICRATE
local FRACUNIT = FRACUNIT

addHook("ThinkFrame", function()
	if not (JUICEBOX.value or JUICEBOX_forcefastrespawn.value) then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		local mo = p.mo
		local ks = p.kartstuff
		p.respawnflash = $ or 0
		p.respawnflash = max(0, $-1)
		if ks[k_respawn] == 48 or ks[k_respawn] == 47 then
			ks[k_respawn] = 2*$/3
		end
		if p.playerstate == PST_DEAD and (not (p.pflags & PF_TIMEOVER)) and (not p.respawnflash) then
			if ks[k_spinouttimer] then
				p.eggsave = 0 -- just give 'em a free pass on this one honestly
				ks[k_eggmanexplode] = 0
			end
			--p.deadtimer = max($, TICRATE-1)
			p.respawnflash = 7
			S_StartSound(nil, sfx_s3kaf, p)
			if p.touchedgates then
				for key, val in pairs(p.touchedgates)
					if (leveltime - val) < 8*TICRATE then
						p.touchedgates[key] = nil
					end
				end
			end
			p.JBhascontrol = 999
			p.JBQRok = false
		end
	end
end)

hud.add(function(v, p, c)
	if not p.respawnflash then return end
	v.fadeScreen(SKINCOLOR_WHITE, min(10, max(p.respawnflash, 0)))
end)