-- JUICEBOX "Hyudoro Misfire"
-- Makes boost items forcibly activate when stolen.
-- Safer shortcuts, but more chaos!

local TICRATE = TICRATE
local KITEM_SNEAKER = KITEM_SNEAKER
local KITEM_ROCKETSNEAKER = KITEM_ROCKETSNEAKER

addHook("ThinkFrame", function()
	if not JUICEBOX.value then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		if p.playerstate != PST_LIVE then continue end
		p.JBlastitem = $ or 0
		local mo = p.mo
		local ks = p.kartstuff
		if ks[k_stolentimer] > TICRATE/2-2 and (p.JBlastitem == KITEM_SNEAKER or p.JBlastitem == KITEM_ROCKETSNEAKER) then
			K_DoSneaker(p, 1)
		end
		p.JBlastitem = ks[k_itemtype]
	end
end)