local TICRATE = TICRATE
local FRACUNIT = FRACUNIT

rawset(_G, "JUICEBOX_CanQuickRecover", function(p)
	return ((p.JBhascontrol < TICRATE*3) and p.JBQRok)
end)

addHook("ThinkFrame", function()
	if not (JUICEBOX.value) then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		
		local mo = p.mo
		local ks = p.kartstuff

		p.JBhascontrol = $ or 0
		p.JBqrok = $ or false

		if (p.kartstuff[k_spinouttimer] or p.kartstuff[k_squishedtimer]) and not (p.respawnflash) then
			p.JBQRok = true
			p.JBhascontrol = 0
		else
			if P_IsObjectOnGround(mo) then -- if we somehow recover from spinout in midair (water?), extend leniency
				p.JBhascontrol = $ + 1 -- i think in airpunt situations this might give you a free MT while already moving forward
			else -- but airtechs already do this so what the fuck ever, can't control for everything and the gains > the losses
				continue -- (also make sure you can't blow your QR in the air, idiot)
			end
			if JUICEBOX_CanQuickRecover(p) and p.cmd.buttons & BT_ACCELERATE and not (p.cmd.buttons & BT_BRAKE) then
				-- we should never branch here with a loss-of-control flag set, so no need to actually recover the player
				ks[k_driftboost] = 21
				S_StartSound(mo, sfx_s23c, p)
				p.JBQRok = false
			end
		end
		
		if p.JBhascontrol and JUICEBOX_CanQuickRecover(p) and (not p.techcuering) then
			local notshitty = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_TECHFLASH)
			notshitty.target = p.mo
			--notshitty.momx, notshitty.momy, notshitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
			notshitty.colorized = true
			notshitty.state = S_TECHFLASH4
			notshitty.color = p.skincolor
			--JUICEBOX_StartLocalSound(sfx_s227, player)
			p.techcuering = true
		end

	end
end)